<!DOCTYPE html>
<html lang="en-us">
<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="generator" content="Source Themes Academic 3.1.0">
  <meta name="generator" content="Hugo 0.50" />
  <meta name="author" content="Jeremy Jackson">

  
  
  
  
    
  
  <meta name="description" content="Working throught part of chapter 3 in NodeJS.">

  
  <link rel="alternate" hreflang="en-us" href="https://ackso.net/project/exercises-for-programmers-3/">

  


  

  

  

  
  
  
  <meta name="theme-color" content="#2962ff">
  

  
  
  
  
    
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha256-eSi1q2PG6J7g7ib17yAaWMcrr5GrtohYChqibrV7PBE=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/academicons/1.8.6/css/academicons.min.css" integrity="sha256-uFVgMKfistnJAfoCUQigIl+JfUaP47GrRKjf6CTPVmw=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.css" integrity="sha256-ygkqlh3CYSUri3LhQxzdcm0n1EQvH2Y+U5S2idbLtxs=" crossorigin="anonymous">

    
    
    
      
    
    
      
      
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" crossorigin="anonymous">
      
    

    

    

  

  
  
  <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Montserrat:400,700|Roboto:400,400italic,700|Roboto+Mono">
  

  <link rel="stylesheet" href="/styles.css">
  

  
  
  

  
  <link rel="alternate" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  <link rel="feed" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  

  <link rel="manifest" href="/site.webmanifest">
  <link rel="icon" type="image/png" href="/img/icon.png">
  <link rel="apple-touch-icon" type="image/png" href="/img/icon-192.png">

  <link rel="canonical" href="https://ackso.net/project/exercises-for-programmers-3/">

  <meta property="twitter:card" content="summary_large_image">
  
  <meta property="og:site_name" content="Sometimes Jeremy Thinks">
  <meta property="og:url" content="https://ackso.net/project/exercises-for-programmers-3/">
  <meta property="og:title" content="Exercises for Programmers 3 - NODEJS | Sometimes Jeremy Thinks">
  <meta property="og:description" content="Working throught part of chapter 3 in NodeJS.">
  
  
    
  <meta property="og:image" content="https://ackso.net/img/icon-192.png">
  <meta property="og:locale" content="en-us">
  
  <meta property="article:published_time" content="2018-01-04T21:41:19-07:00">
  
  <meta property="article:modified_time" content="2018-01-04T21:41:19-07:00">
  

  

  

  <title>Exercises for Programmers 3 - NODEJS | Sometimes Jeremy Thinks</title>

</head>
<body id="top" data-spy="scroll" data-target="#TableOfContents" data-offset="71" >

<nav class="navbar navbar-light fixed-top navbar-expand-lg py-0" id="navbar-main">
  <div class="container">

    
      <a class="navbar-brand" href="/">Sometimes Jeremy Thinks</a>
      
      <button type="button" class="navbar-toggler" data-toggle="collapse"
              data-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
        <span><i class="fas fa-bars"></i></span>
      </button>
      

    
    <div class="collapse navbar-collapse" id="navbar">

      
      
      <ul class="navbar-nav ml-auto">
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#about">
            
            <span>Home</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#posts">
            
            <span>Posts</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#projects">
            
            <span>Projects</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#contact">
            
            <span>Contact</span>
            
          </a>
        </li>

        
        

      

        

        
      </ul>

    </div>
  </div>
</nav>


<article class="article article-project" itemscope itemtype="http://schema.org/Article">

  












  

  
  
  
<div class="article-container pt-3">
  <h1 itemprop="name">Exercises for Programmers 3 - NODEJS</h1>

  

  
    

<div class="article-metadata">

  
  
  <span itemscope itemprop="author" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>
  

  <span class="article-date">
    
    <meta content="2018-01-04 21:41:19 -0700 MST" itemprop="datePublished">
    <time datetime="2018-01-04 21:41:19 -0700 MST" itemprop="dateModified">
      2018-01-04
    </time>
  </span>
  <span itemscope itemprop="publisher" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>

  

  
  
  <span class="middot-divider"></span>
  <a href="/project/exercises-for-programmers-3/#disqus_thread"></a>
  

  

  
  
<div class="share-box" aria-hidden="true">
  <ul class="share">
    <li>
      <a class="twitter"
         href="https://twitter.com/intent/tweet?text=Exercises%20for%20Programmers%203%20-%20NODEJS&amp;url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-3%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-twitter"></i>
      </a>
    </li>
    <li>
      <a class="facebook"
         href="https://www.facebook.com/sharer.php?u=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-3%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-facebook-f"></i>
      </a>
    </li>
    <li>
      <a class="linkedin"
         href="https://www.linkedin.com/shareArticle?mini=true&amp;url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-3%2f&amp;title=Exercises%20for%20Programmers%203%20-%20NODEJS"
         target="_blank" rel="noopener">
        <i class="fab fa-linkedin-in"></i>
      </a>
    </li>
    <li>
      <a class="weibo"
         href="http://service.weibo.com/share/share.php?url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-3%2f&amp;title=Exercises%20for%20Programmers%203%20-%20NODEJS"
         target="_blank" rel="noopener">
        <i class="fab fa-weibo"></i>
      </a>
    </li>
    <li>
      <a class="email"
         href="mailto:?subject=Exercises%20for%20Programmers%203%20-%20NODEJS&amp;body=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-3%2f">
        <i class="fas fa-envelope"></i>
      </a>
    </li>
  </ul>
</div>


  

</div>

    















  
</div>



  <div class="article-container">

    <div class="article-style" itemprop="articleBody">
      

<p>I&rsquo;m in the midst of working through Chapter 3 of
<a href="https://pragprog.com/book/bhwb/exercises-for-programmers" target="_blank">Exercises for Programmers</a>
and decided to write an update on my progress because some of these
individual exercises are starting to get a bit long and convoluted,
so I feel like some of them might benefit from being stand-alone posts.
That will certainly be true for Exercise 10, which I finished up last
night, so for this post I&rsquo;m just going to talk about Exercises 7-9.</p>

<p>Also, <a href="https://github.com/jeremy-j-ackso/exercises-for-programmers-nodejs" target="_blank">here&rsquo;s my Github repo for this project.</a></p>

<h2>Table of Contents</h2>
<nav id="TableOfContents">
<ul>
<li><a href="#background">Background</a></li>
<li><a href="#exercise-7-area-of-a-rectangular-room">Exercise 7 - Area of a Rectangular Room</a></li>
<li><a href="#exercise-8-pizza-party">Exercise 8 - Pizza Party</a></li>
<li><a href="#exercise-9-paint-calculator">Exercise 9 - Paint Calculator</a></li>
</ul>
</nav>


<h1 id="background">Background</h1>

<p>This chapter is all about calculations.
All of the exercises have you taking some input, doing some calculations,
and then writing the output.
As you might expect you end up getting cozy with your basic 4 functions,
<code>Math</code> and <code>Number</code> methods like rounding and defining decimal precision, and validating
that user inputs are parseable digits.
The complexity that is getting introduced in this chapter also really
forces the issue of making sure that you break out your functionality
into smaller component functions, and you can find some rewarding opportunities
for using arguments to slightly modify your function outputs, for instance
when you&rsquo;re converting between imperial and metric units.</p>

<p>As you might expect, with more component functions comes more tests.
Like I mentioned, last night I got through Exercise 10, and already my test file
for this chapter is around 750 lines long.
I have three more exercises to go for this chapter, so I&rsquo;m figuring it will grow
to be over 1000 lines before this chapter ends.
That being the case, I&rsquo;m not going to post my tests in here because they&rsquo;re
getting to be rather boilerplate-y and I personally wouldn&rsquo;t be interested in scrolling
for ages through similar-looking mocha tests.
However you can definitely go check the tests out
<a href="https://github.com/jeremy-j-ackso/exercises-for-programmers-nodejs/blob/master/test/ch3.test.js" target="_blank">here</a>.</p>

<p>My scripts that are implementing the <code>readline</code> functionality for each of the exercises
are also pretty standard for the three exercises here, so I&rsquo;ll just be linking back to
those on Github rather than showing them here.</p>

<p>The most interesting thing I learned from doing these exercises is that JavaScript
parses <a href="https://semver.org/" target="_blank">semantic versioning numbers</a> as Floats (or Integers)
of the Major version, the first dot as the decimal point, and the Minor version.
It ignores the second dot and the Patch version.
This means that:</p>

<pre><code>parseFloat('1.2.3') // returns 1.2
</code></pre>

<p>I had to write tests for this and that also inspired some of my later usage of regular
expressions to validate proper numeric input provided as strings.
That&rsquo;s also something I&rsquo;m going to have to refactor for if I ever go back and do that.
The only reason I discovered this is that when I was writing up my tests I realized
that it should cause the functions to throw an error and I had no idea if it would
or not.</p>

<p>This was just something that popped into my head and I&rsquo;m glad I wrote that test because
JavaScript is perfectly happy to pretend that these are numbers and will do its
best to accomodate them as such.</p>

<p>I also tested this in Python and R, and both of them generated errors when attempting
to convert the semver string to some type of numeric, which is what I would have
expected from JavaScript as well.</p>

<h1 id="exercise-7-area-of-a-rectangular-room">Exercise 7 - Area of a Rectangular Room</h1>

<p>The most fancy thing here is the use of the <code>*=</code> infix operator to convert
from imperial to metric in the case that the <code>units</code> required is metric.</p>

<p><a href="https://github.com/jeremy-j-ackso/exercises-for-programmers-nodejs/blob/master/ch3/area-of-rectangle-room.js" target="_blank">Here&rsquo;s the <code>readline</code> function calling it.</a></p>

<pre><code class="language-javascript">/* eslint comma-dangle: &quot;off&quot;, comma-spacing: &quot;off&quot; */

function sqft(length, width) {
  const invalids = [null, undefined,]
  if (invalids.includes(length) || invalids.includes(width)) {
    throw new Error('inputs must not be null or undefined')
  }

  if (!parseFloat(length) || !parseFloat(width)) {
    throw new Error('length and width must be digits')
  }

  return `${areaOfRectangle(length, width, 'feet')} square feet`
}

function sqmeters(length, width) {
  const invalids = [null, undefined,]
  if (invalids.includes(length) || invalids.includes(width)) {
    throw new Error('inputs must not be null or undefined')
  }

  if (!parseFloat(length) || !parseFloat(width)) {
    throw new Error('length and width must be digits')
  }

  return `${areaOfRectangle(length, width, 'meters')} square meters`
}

function dimensions(length, width) {
  const invalids = [null, undefined,]
  if (invalids.includes(length) || invalids.includes(width)) {
    throw new Error('inputs must not be null or undefined')
  }

  if (!parseFloat(length) || !parseFloat(width)) {
    throw new Error('length and width must be digits')
  }

  return `You entered dimensions of ${length} feet by ${width} feet.`
}

function areaOfRectangle(length, width, unit) {
  const invalids = [null, undefined,]
  if (invalids.includes(length) || invalids.includes(width) || invalids.includes(unit)) {
    throw new Error('inputs must not be null or undefined')
  }

  if (!['feet', 'meters'].includes(unit)) {
    throw new Error('units must be either \'feet\' or \'meters\'')
  }

  if (!parseFloat(length) || !parseFloat(width)) {
    throw new Error('length and width must be digits')
  }

  let area = length * width
  if (unit === 'meters') area *= 0.09290304
  return area.toFixed(3)
}

module.exports = {
  dimensions,
  sqft,
  sqmeters,
  areaOfRectangle,
}
</code></pre>

<h1 id="exercise-8-pizza-party">Exercise 8 - Pizza Party</h1>

<p>This one has you doing both integer division and grabbing remainders!
I also like that I had to write the <code>pluralizer()</code> function to correctly
decide what word to use based on the number values.
Also, <code>aboutTheParty()</code> has some extreme string templating going on.</p>

<p><a href="https://github.com/jeremy-j-ackso/exercises-for-programmers-nodejs/blob/master/ch3/pizza-party.js" target="_blank">Here&rsquo;s the <code>readline</code> function calling it.</a></p>

<pre><code class="language-javascript">function remainingPieces(people, pizzas, pieces) {
  if (typeof people !== 'string' || typeof pizzas !== 'string' || typeof pieces !== 'string') {
    throw new Error('arguments to this function must be provided as strings')
  }

  if (!Number.isInteger(parseFloat(people)) ||
    !Number.isInteger(parseFloat(pizzas)) ||
    !Number.isInteger(parseFloat(pieces))) {
    throw new Error('arguments must be parseable integer digits')
  }

  const total_pieces = pizzas * pieces
  const pieces_remain = total_pieces % people
  if (pieces_remain === 1) {
    return `There is ${pieces_remain} leftover piece.`
  }
  return `There are ${pieces_remain} leftover pieces.`
}

function piecesPerPerson(people, pizzas, pieces) {
  if (typeof people !== 'string' || typeof pizzas !== 'string' || typeof pieces !== 'string') {
    throw new Error('arguments to this function must be provided as strings')
  }

  if (!Number.isInteger(parseFloat(people)) ||
    !Number.isInteger(parseFloat(pizzas)) ||
    !Number.isInteger(parseFloat(pieces))) {
    throw new Error('arguments must be parseable integer digits')
  }

  const total_pieces = pizzas * pieces
  const pieces_each = Math.floor(total_pieces / people)
  return `Each person gets ${pieces_each} pieces of pizza.`
}

function aboutTheParty(people, pizzas, pieces) {
  if (typeof people !== 'string' || typeof pizzas !== 'string' || typeof pieces !== 'string') {
    throw new Error('arguments to this function must be provided as strings')
  }

  if (!Number.isInteger(parseFloat(people)) ||
    !Number.isInteger(parseFloat(pizzas)) ||
    !Number.isInteger(parseFloat(pieces))) {
    throw new Error('arguments must be parseable integer digits')
  }

  return `${people} ${pluralizer('people', people)} with ${pizzas} ${pluralizer('pizzas', pizzas)}, each pizza having ${pieces} ${pluralizer('pieces', pieces)}`
}

function pluralizer(type, val) {
  const plurals = {
    people: ['person', 'people'],
    pizzas: ['pizza', 'pizzas'],
    pieces: ['piece', 'pieces'],
  }

  if (!Object.keys(plurals).includes(type)) {
    throw new Error('type must be one of [\'person\', \'pizzas\', \'pieces\']')
  }

  if (typeof val !== 'string' || !Number.isInteger(parseFloat(val))) {
    throw new Error('val must be a parseable integer digit supplied as a string')
  }

  let lookup_val = val - 1
  if (lookup_val &gt; 1) lookup_val = 1
  return plurals[type][lookup_val]
}

module.exports = {
  remainingPieces,
  piecesPerPerson,
  aboutTheParty,
  pluralizer,
}
</code></pre>

<h1 id="exercise-9-paint-calculator">Exercise 9 - Paint Calculator</h1>

<p>This is another &ldquo;area of a rectangle&rdquo; calculator since it&rsquo;s just focused on the
ceiling of a room.
It does impose some nice rounding requirements though.</p>

<p><a href="https://github.com/jeremy-j-ackso/exercises-for-programmers-nodejs/blob/master/ch3/paintCalc.js" target="_blank">Here&rsquo;s the <code>readline</code> function calling it.</a></p>

<pre><code class="language-javascript">function paintCalculator(length, width) {
  if (!/^[0-9]+\.?[0-9]*$/.test(length) || typeof length !== 'string') {
    throw new Error('length must be a parseable number provided as a string')
  }

  if (!/^[0-9]+\.?[0-9]*$/.test(width) || typeof width !== 'string') {
    throw new Error('width must be a parseable number provided as a string')
  }

  const galPerSqFt = 1 / 350
  const sqft_num = dimensions_paint(length, width)

  return Math.ceil(sqft_num * galPerSqFt)
}

function dimensions_paint(length, width) {
  if (!/^[0-9]+\.?[0-9]*$/.test(length) || typeof length !== 'string') {
    throw new Error('length must be a parseable number provided as a string')
  }

  if (!/^[0-9]+\.?[0-9]*$/.test(width) || typeof width !== 'string') {
    throw new Error('width must be a parseable number provided as a string')
  }

  const length_num = parseFloat(length)
  const width_num = parseFloat(width)
  return length_num * width_num
}

module.exports = {
  paintCalculator,
  dimensions_paint,
}
</code></pre>

    </div>

    


<div class="article-tags">
  
  <a class="badge badge-light" href="/tags/programming-exercises/">programming exercises</a>
  
  <a class="badge badge-light" href="/tags/nodejs/">nodejs</a>
  
</div>



    






<div class="media author-card" itemscope itemtype="http://schema.org/Person">
  
  <img class="portrait mr-3" src="/img/portrait.jpg" itemprop="image" alt="Avatar">
  
  <div class="media-body">
    <h5 class="card-title" itemprop="name"><a href="/">Jeremy Jackson</a></h5>
    <h6 class="card-subtitle">Software Engineering and Data Science</h6>
    
    <ul class="network-icon" aria-hidden="true">
      
      
      
      
      
      
      
      
      <li>
        <a itemprop="sameAs" href="mailto:jeremy_j@ackso.net" >
          <i class="fa fa-envelope"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//twitter.com/jeremy_j_ackso" >
          <i class="fab fa-twitter"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//github.com/jeremy-j-ackso" >
          <i class="fab fa-github"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//gitlab.com/jeremy.jackson" >
          <i class="fab fa-gitlab"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//linkedin.com/in/jeremy-jackson-249878153" >
          <i class="fab fa-linkedin"></i>
        </a>
      </li>
      
    </ul>
  </div>
</div>




    
    
    
    
    
    
    

    

      
      
      

      
      
      
      

      
      
      
      
    

  </div>
</article>



<div class="container">
  <footer class="site-footer">
  

  <p class="powered-by">
    &copy; 2017 Jeremy T Jackson &middot; 

    Powered by the
    <a href="https://sourcethemes.com/academic/" target="_blank" rel="noopener">Academic theme</a> for
    <a href="https://gohugo.io" target="_blank" rel="noopener">Hugo</a>.

    
    <span class="float-right" aria-hidden="true">
      <a href="#" id="back_to_top">
        <span class="button_icon">
          <i class="fas fa-chevron-up fa-2x"></i>
        </span>
      </a>
    </span>
    
  </p>
</footer>

</div>


<div id="modal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Cite</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <pre><code class="tex hljs"></code></pre>
      </div>
      <div class="modal-footer">
        <a class="btn btn-outline-primary my-1 js-copy-cite" href="#" target="_blank">
          <i class="fas fa-copy"></i> Copy
        </a>
        <a class="btn btn-outline-primary my-1 js-download-cite" href="#" target="_blank">
          <i class="fas fa-download"></i> Download
        </a>
        <div id="modal-error"></div>
      </div>
    </div>
  </div>
</div>

    

    
    
    
    
    <script src="/js/mathjax-config.500a6cbb2c0f345fcecc21b3116d6637aa78f1f11db8081ea581abe05390c2e8f3bbffe61be3cf0217baf785c40efceabe51050a4f007e69af94efd3643260e8.js" integrity="sha512-UApsuywPNF/OzCGzEW1mN6p48fEduAgepYGr4FOQwujzu//mG&#43;PPAhe694XEDvzqvlEFCk8AfmmvlO/TZDJg6A=="></script>
    

    
    
    
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js" integrity="sha512-+NqPlbbtM1QqiK8ZAo4Yrj2c4lNQoGv8P79DPtKzj++l5jnN39rHA/xsqn8zE9l0uSoxaCdrOgFs6yjyfbBxSg==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.imagesloaded/4.1.3/imagesloaded.pkgd.min.js" integrity="sha512-umsR78NN0D23AzgoZ11K7raBD+R6hqKojyBZs1w8WvYlsI+QuKRGBx3LFCwhatzBunCjDuJpDHwxD13sLMbpRA==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha256-VsEqElsCHSGmnmHXGQzvoWjWwoznFSZc6hs7ARLRacQ=" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.isotope/3.0.4/isotope.pkgd.min.js" integrity="sha512-VDBOIlDbuC4VWxGJNmuFRQ0Li0SKkDpmGyuhAG5LTDLd/dJ/S0WMVxriR2Y+CyPL5gzjpN4f/6iqWVBJlht0tQ==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.js" integrity="sha256-X5PoE3KU5l+JcX+w09p/wHl9AzK333C4hJ2I9S5mD4M=" crossorigin="anonymous"></script>

      
        
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js" integrity="sha256-/BfiIkHlHoVihZdc6TFuj7MmJ0TWcWsMXkeDFwhi0zw=" crossorigin="anonymous"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/python.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/r.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/bash.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/css.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/diff.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/javascript.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/json.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/markdown.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/nginx.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/processing.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/scala.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/sql.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/tex.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/vim.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/yaml.min.js"></script>
        
      

      
      
      <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/MathJax.js?config=TeX-AMS_CHTML-full" integrity="sha256-GhM+5JHb6QUzOQPXSJLEWP7R73CbkisjzK5Eyij4U9w=" crossorigin="anonymous" async></script>
      
    

    <script src="/js/hugo-academic.js"></script>
    

    
    

    
    
    
    <script id="dsq-count-scr" src="//ackso-net.disqus.com.disqus.com/count.js" async></script>
    

    
    
    <script>hljs.initHighlightingOnLoad();</script>
    

    
    
    <script>
      const search_index_filename = "/index.json";
      const i18n = {
        'placeholder': "Search...",
        'results': "Search Results",
        'no_results': "No results found"
      };
      const content_type = {
        'post': "Posts",
        'project': "Projects",
        'publication' : "Publications",
        'talk' : "Talks"
        };
    </script>
    

    
    

    

    
    

    
    

  </body>
</html>

